package question1;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Arrays;

public abstract class CompositeSpecification<T> extends Specification<T> implements Iterable<Specification<T>>{

    private List<Specification<T>> specifications;

    public CompositeSpecification(){
        this.specifications = new ArrayList<>();
    }

    public CompositeSpecification<T> add(Specification<T> spec){
        this.specifications.add(spec);
        return this;
    }

    public Iterator<Specification<T>> iterator(){
        return specifications.iterator();
    }

    public String interpreter(){
        String str="(";
        Iterator<Specification<T>> it = this.iterator();
        while(it.hasNext()) {
            str += it.next().interpreter();
            if(it.hasNext())
                str += ", ";
        }
        str += ")";
        return str;
    }

}
