package question2;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;

public class MacroCommand<R> extends Command<R> implements Iterable<Command<R>>{

    private List<Command<R>> commandes;

    public MacroCommand(){
        commandes = new ArrayList<>();
    }

    public MacroCommand<R> add(Command<R> command){
        this.commandes.add(command);
        return this;
    }
    

    public R execute(R r) throws Exception{
        for(Command<R> cmd :this) {
            r = cmd.execute(r);
        }
        return r;
    }

    public Iterator<Command<R>> iterator(){
        return this.commandes.iterator();
    }

    public String interpreter(){
        String str="(";
        Iterator<Command<R>> it = this.iterator();
        while(it.hasNext()) {
            str += it.next().interpreter();
            if(it.hasNext())
                str += " -> ";
        }
        str += ")";
        return str;
   }
}