package question3;

import question1.*;
import question2.*;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.lang.reflect.*;

public class ReflectionRule<E,R> extends Rule<E,R> {

    public void setSpecification(String spec){
        try {
            Class<?> specificationClass = Class.forName(spec);
            this.specification = (Specification) specificationClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void setCommand(String cmd){
        try {
            Class<?> commandClass = Class.forName(cmd);
            this.command = (Command) commandClass.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public R execute(E e,R r)throws Exception{
        Method specificationMethod = null, commandMethod = null;
        if(this.specification != null)
            specificationMethod = specification.getClass().getDeclaredMethod("isSatisfiedBy", e.getClass());
        if(this.command != null)
            commandMethod = command.getClass().getDeclaredMethod("execute", r.getClass());   
        boolean condition = (boolean) specificationMethod.invoke(specification, e);
        if(condition)
            return (R) commandMethod.invoke(command,r);
        return r;
    }

}