package question3;

import question1.*;
import question2.*;

public class TestsRule extends junit.framework.TestCase {
   
    public void testSimpleAvecDesEntiers() throws Exception{
        Specification<Integer> inf = new EstInferieur(4); 
        MacroCommand<Integer> plus2 = new MacroCommand<Integer>(); 
        plus2.add(new Inc()).add(new Inc()); 

        Rule<Integer,Integer> rule = new Rule<>(inf,plus2);    
        System.out.println( "rule:" + rule.accept(new StringVisitor()));
        assertEquals("(estInferieur_a_4)((inc -> inc));\n",rule.accept(new StringVisitor()));
        
        PrintRule print = new PrintRule();
        System.out.println( "print: " + print.accept(new StringVisitor()));
        assertEquals("(true)(print);\n",print.accept(new StringVisitor()));
                
        Integer res = 0, x = 3;

        res = rule.execute(x,res);       // [res==0,x==3]if inf(x,4) res = plus2.execute(res);
        assertEquals(new Integer(2),res);   // [res==2]

        Integer res1 = rule.execute(5,res); // [x==5]if inf(x,4) res1 = plus2.execute(res);
        assertEquals(new Integer(2), res1); // [res==2]

        ClusterRules<Integer,Integer> cluster = new ClusterRules("cluster1");
        cluster.add(rule).add(rule).add(rule);

        Integer res2 = cluster.execute(2,0);
        assertEquals(new Integer(6),res2);
        
        
        ClusterRules<Integer,Integer> cluster2 = new ClusterRules("cluster2");
        cluster2.add(rule).add(print).add(rule).add(print);
        cluster.add(cluster2);
        ClusterRules<Integer,Integer> cluster3 = new ClusterRules("cluster3");
        cluster3.add(rule).add(print).add(rule).add(print);
        cluster.add(cluster3);
        res2 = cluster.execute(2,0);
        assertEquals(new Integer(14),res2);
        System.out.println(cluster.accept(new StringVisitor()));
    }

    public void testReflectionRule() throws Exception{
 
            ReflectionRule<Integer,Integer> rule = new ReflectionRule();
            rule.setSpecification("question3.EstInferieur");
           
            EstInferieur inf = (EstInferieur)rule.getSpecification();
            inf.setValeur(4); 
            rule.setCommand("question3.Inc");

            Integer i = rule.execute(0,5);
            assertEquals(new Integer(6),i);

    }
    
}
